<?php

namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\PrioridadeManutService;

class PrioridadeManutController extends FMCrud{
    protected $dataSourceName = 'fcm_checklistagend';
    protected $PrioridadeManutService;

    public function __construct($crudService, $environment, PrioridadeManutService $PrioridadeManutService) {
        parent::__construct($crudService, $environment);
        $this->PrioridadeManutService = $PrioridadeManutService;
    }

    public function rotaBase(DTO\Request $request, DTO\Response $response) {
        $method = $request->getMethod();
        $parametros = $request->getParameters();
        $prioridade = '';

        if ($method== "POST") {
            $prioridade = $this->PrioridadeManutService-> inserirPrioridade($parametros);
        } else if ($method == "GET") {
           $prioridade = $this->PrioridadeManutService->getInformacoesPrioridades();
        }

        $dtsVal = new DataSet('prioridade', [$prioridade]);
        $response->addDataSet($dtsVal);
    }
}

?>