/******************************************************************************/
/* Sistemas Integrados TECNISA                                                */
/*                                                                            */
/* Compras e Suprimentos                                                      */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/* Nome: 8540_SUPVIE_PRAZO_MEDIO_AF                                           */
/*                                                                            */
/* Descrio:                                                                 */
/* Calcula o prazo medio para determinado produto na AF                       */
/*                                                                            */
/*                                                                            */
/* Criao:                                                                   */
/* 27/10/2000 - Joo Fernando dos Reis Corra                                 */
/*                                                                            */
/******************************************************************************/
/******************************************************************************/
/* @C:\SISTEMAS\DBA\SQL\MSSQL\8540_SUPVIE_PRAZO_MEDIO_AF.SQL                 */
/* @H:\SISTEMAS\DBA\SQL\MSSQL\8540_SUPVIE_PRAZO_MEDIO_AF.SQL                 */
/******************************************************************************/

IF EXISTS (SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'PRAZO_MEDIO_AF'  and
            Xtype = 'V'                  and
            u.uid = o.uid               and
            u.name = USER)
  DROP VIEW PRAZO_MEDIO_AF;
GO

CREATE VIEW PRAZO_MEDIO_AF AS
SELECT
   CDFILDEST,
   CDFILLANC,
   NRAUTOFORN,
   DTPROGENTAF,
   CDPRODUTO,
   CDMARCA,
   VRPRAZOMED,
   IDTPFORPGTAF
FROM
(
SELECT
   ITEMAUTF.CDFILDEST,
   ITEMAUTF.CDFILLANC,
   ITEMAUTF.NRAUTOFORN,
   ITEMAUTF.DTPROGENTAF,
   ITEMAUTF.CDPRODUTO,
   ITEMAUTF.CDMARCA,
   SUM((PRAZOPGTAF.NRDIASPGTOAF * ((ITEMAUTF.QTPROGENTAF * ITEMAUTF.VRPREUNIAF) * (PRAZOPGTAF.VRPERCPGTOAF/100)))/(ITEMAUTF.QTPROGENTAF * ITEMAUTF.VRPREUNIAF)) AS VRPRAZOMED,
   AUTOFORNE.IDTPFORPGTAF
FROM
   PRAZOPGTAF,
   ITEMAUTF,
   AUTOFORNE
WHERE
   PRAZOPGTAF.CDFILDEST  = ITEMAUTF.CDFILDEST AND
   PRAZOPGTAF.CDFILLANC  = ITEMAUTF.CDFILLANC AND
   PRAZOPGTAF.NRAUTOFORN = ITEMAUTF.NRAUTOFORN AND
   AUTOFORNE.CDFILDEST  = ITEMAUTF.CDFILDEST AND
   AUTOFORNE.CDFILLANC  = ITEMAUTF.CDFILLANC AND
   AUTOFORNE.NRAUTOFORN = ITEMAUTF.NRAUTOFORN AND
   AUTOFORNE.IDTPFORPGTAF = 'V' AND
   (AUTOFORNE.IDAFFORALIM  = 'N') AND
   (AUTOFORNE.IDSITUATUAAF IS NULL)
GROUP BY
   ITEMAUTF.CDFILDEST,
   ITEMAUTF.CDFILLANC,
   ITEMAUTF.NRAUTOFORN,
   ITEMAUTF.DTPROGENTAF,
   ITEMAUTF.CDPRODUTO,
   ITEMAUTF.CDMARCA,
   AUTOFORNE.IDTPFORPGTAF
UNION ALL
SELECT
   ITEM.CDFILDEST,
   ITEM.CDFILLANC,
   ITEM.NRAUTOFORN,
   ITEM.DTPROGENTAF,
   ITEM.CDPRODUTO,
   ITEM.CDMARCA,
   AVG(CONVERT(NUMERIC, DATEADD(MM, DATEPART(DD, DTDATA) - 1, CONVERT(DATETIME, CONVERT(VARCHAR, ITEM.DTPROGENTAF - DAY(ITEM.DTPROGENTAF) + ITEM.NRDIAPGFIXAF, 103))) - CONVERT(DATETIME, CONVERT(VARCHAR, ITEM.DTPROGENTAF, 103)))) AS VRPRAZOMED,
   ITEM.IDTPFORPGTAF
FROM
   DATA,
(SELECT
   ITEMAUTF.CDFILDEST,
   ITEMAUTF.CDFILLANC,
   ITEMAUTF.NRAUTOFORN,
   ITEMAUTF.DTPROGENTAF,
   ITEMAUTF.CDPRODUTO,
   ITEMAUTF.CDMARCA,
   AUTOFORNE.NRPARCPGTOAF,
   AUTOFORNE.NRDIAPGFIXAF,
   AUTOFORNE.IDTPFORPGTAF
FROM
   AUTOFORNE,
   ITEMAUTF
WHERE
   (ITEMAUTF.CDFILDEST = AUTOFORNE.CDFILDEST) AND
   (ITEMAUTF.CDFILLANC = AUTOFORNE.CDFILLANC) AND
   (ITEMAUTF.NRAUTOFORN = AUTOFORNE.NRAUTOFORN) AND
   (AUTOFORNE.IDTPFORPGTAF = 'F') AND
   (AUTOFORNE.IDUTDIAPGTAF = 'I') AND
   (AUTOFORNE.IDAFFORALIM  = 'N') AND
   (AUTOFORNE.IDSITUATUAAF IS NULL) AND
   (CONVERT(DATETIME, CONVERT(VARCHAR, ITEMAUTF.DTPROGENTAF - DAY(ITEMAUTF.DTPROGENTAF) + AUTOFORNE.NRDIAPGFIXAF, 103)) > ITEMAUTF.DTPROGENTAF)
) ITEM
WHERE
   DATA.DTDATA BETWEEN DATEADD(DD, 1, ('31/12/1999')) AND DATEADD(DD, ITEM.NRPARCPGTOAF, '31/12/1999')
GROUP BY
   ITEM.CDFILDEST,
   ITEM.CDFILLANC,
   ITEM.NRAUTOFORN,
   ITEM.DTPROGENTAF,
   ITEM.CDPRODUTO,
   ITEM.CDMARCA,
   ITEM.IDTPFORPGTAF
UNION ALL
SELECT
   ITEM.CDFILDEST,
   ITEM.CDFILLANC,
   ITEM.NRAUTOFORN,
   ITEM.DTPROGENTAF,
   ITEM.CDPRODUTO,
   ITEM.CDMARCA,
   AVG(CONVERT(NUMERIC, DATEADD(MM, DATEPART(DD, DTDATA) - 1, CONVERT(DATETIME, CONVERT(VARCHAR, DATEADD(MM, 1, ITEM.DTPROGENTAF - DAY(ITEM.DTPROGENTAF)) + ITEM.NRDIAPGFIXAF, 103))) - CONVERT(DATETIME, CONVERT(VARCHAR, ITEM.DTPROGENTAF, 103)))) AS VRPRAZOMED,
   ITEM.IDTPFORPGTAF
FROM
   DATA,
(SELECT
   ITEMAUTF.CDFILDEST,
   ITEMAUTF.CDFILLANC,
   ITEMAUTF.NRAUTOFORN,
   ITEMAUTF.DTPROGENTAF,
   ITEMAUTF.CDPRODUTO,
   ITEMAUTF.CDMARCA,
   AUTOFORNE.NRPARCPGTOAF,
   AUTOFORNE.NRDIAPGFIXAF,
   AUTOFORNE.IDTPFORPGTAF
FROM
   AUTOFORNE,
   ITEMAUTF
WHERE
   (ITEMAUTF.CDFILDEST = AUTOFORNE.CDFILDEST) AND
   (ITEMAUTF.CDFILLANC = AUTOFORNE.CDFILLANC) AND
   (ITEMAUTF.NRAUTOFORN = AUTOFORNE.NRAUTOFORN) AND
   (AUTOFORNE.IDTPFORPGTAF = 'F') AND
   (AUTOFORNE.IDUTDIAPGTAF = 'I') AND  
   (AUTOFORNE.IDAFFORALIM  = 'N') AND
   (AUTOFORNE.IDSITUATUAAF IS NULL) AND
   (CONVERT(DATETIME, CONVERT(VARCHAR, ITEMAUTF.DTPROGENTAF - DAY(ITEMAUTF.DTPROGENTAF) + AUTOFORNE.NRDIAPGFIXAF, 103)) <= ITEMAUTF.DTPROGENTAF)
) ITEM
WHERE
   DATA.DTDATA BETWEEN DATEADD(DD, 1, ('31/12/1999')) AND DATEADD(DD, ITEM.NRPARCPGTOAF, '31/12/1999')
GROUP BY
   ITEM.CDFILDEST,
   ITEM.CDFILLANC,
   ITEM.NRAUTOFORN,
   ITEM.DTPROGENTAF,
   ITEM.CDPRODUTO,
   ITEM.CDMARCA,
   ITEM.IDTPFORPGTAF
UNION ALL
SELECT
   ITEM.CDFILDEST,
   ITEM.CDFILLANC,
   ITEM.NRAUTOFORN,
   ITEM.DTPROGENTAF,
   ITEM.CDPRODUTO,
   ITEM.CDMARCA,
   AVG(CONVERT(NUMERIC, DATEADD(MM, DATEPART(DD, DTDATA) - 1, CONVERT(DATETIME, CONVERT(VARCHAR, DATEADD(MM, 1, ITEM.DTPROGENTAF - DAY(ITEM.DTPROGENTAF)) + ITEM.NRDIAPGFIXAF, 103))) - CONVERT(DATETIME, CONVERT(VARCHAR, ITEM.DTPROGENTAF, 103)))) AS VRPRAZOMED,
   ITEM.IDTPFORPGTAF
FROM
   DATA,
(SELECT
   ITEMAUTF.CDFILDEST,
   ITEMAUTF.CDFILLANC,
   ITEMAUTF.NRAUTOFORN,
   ITEMAUTF.DTPROGENTAF,
   ITEMAUTF.CDPRODUTO,
   ITEMAUTF.CDMARCA,
   AUTOFORNE.NRPARCPGTOAF,
   AUTOFORNE.NRDIAPGFIXAF,
   AUTOFORNE.IDTPFORPGTAF
FROM
   AUTOFORNE,
   ITEMAUTF
WHERE
   (ITEMAUTF.CDFILDEST = AUTOFORNE.CDFILDEST) AND
   (ITEMAUTF.CDFILLANC = AUTOFORNE.CDFILLANC) AND
   (ITEMAUTF.NRAUTOFORN = AUTOFORNE.NRAUTOFORN) AND
   (AUTOFORNE.IDTPFORPGTAF = 'F') AND
   (AUTOFORNE.IDUTDIAPGTAF = 'E') AND
   (AUTOFORNE.IDAFFORALIM  = 'N') AND
   (AUTOFORNE.IDSITUATUAAF IS NULL)
) ITEM
WHERE
   DATA.DTDATA BETWEEN DATEADD(DD, 1, ('31/12/1999')) AND DATEADD(DD, ITEM.NRPARCPGTOAF, '31/12/1999')
GROUP BY
   ITEM.CDFILDEST,
   ITEM.CDFILLANC,
   ITEM.NRAUTOFORN,
   ITEM.DTPROGENTAF,
   ITEM.CDPRODUTO,
   ITEM.CDMARCA,
   ITEM.IDTPFORPGTAF
UNION ALL
SELECT
   ITEMAUTF.CDFILDEST,
   ITEMAUTF.CDFILLANC,
   ITEMAUTF.NRAUTOFORN,
   ITEMAUTF.DTPROGENTAF,
   ITEMAUTF.CDPRODUTO,
   ITEMAUTF.CDMARCA,
   0 AS VRPRAZOMED,
   AUTOFORNE.IDTPFORPGTAF
FROM
   ITEMAUTF,
   AUTOFORNE
WHERE
   (ITEMAUTF.CDFILDEST = AUTOFORNE.CDFILDEST) AND
   (ITEMAUTF.CDFILLANC = AUTOFORNE.CDFILLANC) AND
   (ITEMAUTF.NRAUTOFORN = AUTOFORNE.NRAUTOFORN) AND
   (AUTOFORNE.IDTPFORPGTAF IS NULL)AND
   (AUTOFORNE.IDAFFORALIM  = 'N') AND
   (AUTOFORNE.IDSITUATUAAF IS NULL)
) PRAZO_MEDIO_AF
GO
