import { Component } from 'vue-property-decorator';
import { ZdComponentRender } from '@zeedhi/vuetify';
import { Calendar } from './Calendar';

@Component
export default class ZdCalendar extends ZdComponentRender {
  public instance!: Calendar;

  public instanceType: typeof Calendar = Calendar;

  public selectedElement?: any = null;

  public selectedEvent?: Object = {};

  public selectedOpen?: boolean = false;

  public mode?: string = 'stack';

  public value?: string = '';

  public focusM?: string = '';

  public defaultType: Object = { txt: 'Mês', val: 'month' };

  public weekday?:Array<Number> = [0, 1, 2, 3, 4, 5, 6];

  public weekdays?:Array<Object> = [
    { text: 'Sun - Sat', value: [0, 1, 2, 3, 4, 5, 6] },
    { text: 'Mon - Sun', value: [1, 2, 3, 4, 5, 6, 0] },
    { text: 'Mon - Fri', value: [1, 2, 3, 4, 5] },
    { text: 'Mon, Wed, Fri', value: [1, 3, 5] },
  ];

  public showEvent({ nativeEvent, event } : any) {
    const open = () => {
      this.selectedEvent = event;
      this.selectedElement = nativeEvent.target;
      setTimeout(() => {
        this.selectedOpen = true;
      }, 10);
    };

    if (this.selectedOpen) {
      this.selectedOpen = false;
      setTimeout(open, 10);
    } else {
      open();
    }

    nativeEvent.stopPropagation();
  }

  getEventColor(event: any) {
    return event.color;
  }
}
